#include "v3.h"


// access to elements
float& V3::operator[](int i) {

  return xyz[i];

}

V3::V3(float x, float y, float z) {

  xyz[0] = x;
  xyz[1] = y;
  xyz[2] = z;

}

float V3::operator*(V3 v) {

  return 
    v[0]*xyz[0] + 
    v[1]*xyz[1] + 
    v[2]*xyz[2];

}


V3 V3::operator+(V3 v) {

  V3 ret(xyz[0]+v[0], xyz[1]+v[1], xyz[2]+v[2]);
  return ret;

}

V3 V3::operator-(V3 v) {

  V3 ret(xyz[0]-v[0], xyz[1]-v[1], xyz[2]-v[2]);
  return ret;

}

ostream& operator<<(ostream &ostr, V3 v) {

  ostr << v[0] << " " << v[1] << " " << v[2] << " ";
  return ostr;

}

V3 V3::operator*(float scf) {

  V3 ret = *this;
  ret[0] *= scf;
  ret[1] *= scf;
  ret[2] *= scf;
  return ret;

}


V3 V3::operator/(float scf) {

  V3 ret = *this;
  ret[0] /= scf;
  ret[1] /= scf;
  ret[2] /= scf;
  return ret;

}

void V3::SetFromColor(unsigned int color) {

  unsigned char *rgb = (unsigned char*)(&color);
  xyz[0] = ((float)rgb[0])/255.0f;
  xyz[1] = ((float)rgb[1])/255.0f;
  xyz[2] = ((float)rgb[2])/255.0f;

}

unsigned int V3::GetColor() {

  unsigned int rgb[3];
  float _xyz[3];
  for (int i = 0; i < 3; i++) {
    if (xyz[i] < 0.0f)
      _xyz[i] = 0.0f;
    else if (xyz[i] > 1.0f)
      _xyz[i] = 1.0f;
    else
      _xyz[i] = xyz[i];
  }
  rgb[0] = (int) (_xyz[0]*255.0f);
  rgb[1] = (int) (_xyz[1]*255.0f);
  rgb[2] = (int) (_xyz[2]*255.0f);
  return 0xFF000000 + rgb[0] + rgb[1]*256 + rgb[2]*256*256;

}

